"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styledComponents = [[_index.StyledRoot, 'StyledRoot'], [_index.StyledCalendarContainer, 'StyledCalendarContainer'], [_index.StyledHeader, 'StyledHeader'], [_index.StyledMonthHeader, 'StyledMonthHeader'], [_index.StyledMonth, 'StyledMonth'], [_index.StyledWeek, 'StyledWeek'], [_index.StyledDay, 'StyledDay']];
var props = [['$disabled'], ['$isHighlighted'], ['$isHovered'], ['$outsideMonth'], ['$selected']];
describe('Component styled components', function () {
  test.each(styledComponents)('Basic render', function (Component, name) {
    var component = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
    expect(component.instance().getStyles()).toMatchSnapshot("".concat(name, " has correct styles"));
  });
  test.each(props)('Prop based styles', function (prop) {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledDay, _defineProperty({}, prop, true)));
    expect(component.instance().getStyles()).toMatchSnapshot("StyledDay has correct styles when ".concat(prop, " is set to true"));
  });
});