"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledDay = exports.StyledWeek = exports.StyledMonth = exports.StyledMonthHeader = exports.StyledHeader = exports.StyledCalendarContainer = exports.StyledRoot = void 0;

var _index = require("../styles/index.js");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Main component container element
 */
var StyledRoot = (0, _index.styled)('div', function (props) {
  var _props$$theme = props.$theme,
      typography = _props$$theme.typography,
      colors = _props$$theme.colors,
      borders = _props$$theme.borders;
  return _objectSpread({}, typography.font400, {
    color: colors.black,
    backgroundColor: colors.white,
    textAlign: 'center',
    borderRadius: borders.useRoundedCorners ? borders.radius200 : '0px',
    display: 'inline-block'
  });
});
exports.StyledRoot = StyledRoot;
var StyledCalendarContainer = (0, _index.styled)('div', function (props) {
  var sizing = props.$theme.sizing;
  return {
    paddingTop: sizing.scale400,
    paddingBottom: sizing.scale500,
    paddingLeft: sizing.scale600,
    paddingRight: sizing.scale600
  };
});
exports.StyledCalendarContainer = StyledCalendarContainer;
var StyledHeader = (0, _index.styled)('div', function (props) {
  var _props$$theme2 = props.$theme,
      colors = _props$$theme2.colors,
      sizing = _props$$theme2.sizing,
      borders = _props$$theme2.borders;
  var borderRadius = borders.useRoundedCorners ? borders.radius200 : '0px';
  return {
    color: colors.white,
    display: 'flex',
    justifyContent: 'space-between',
    alignItems: 'center',
    paddingTop: sizing.scale500,
    paddingBottom: sizing.scale500,
    paddingLeft: sizing.scale600,
    paddingRight: sizing.scale600,
    backgroundColor: colors.primary,
    borderRadius: "".concat(borderRadius, " ").concat(borderRadius, " 0 0")
  };
});
exports.StyledHeader = StyledHeader;
var StyledMonthHeader = (0, _index.styled)('div', function (props) {
  return {
    whiteSpace: 'no-wrap'
  };
});
exports.StyledMonthHeader = StyledMonthHeader;
var StyledMonth = (0, _index.styled)('div', function (props) {
  return {
    display: 'inline-block'
  };
});
exports.StyledMonth = StyledMonth;
var StyledWeek = (0, _index.styled)('div', function (props) {
  return {
    whiteSpace: 'no-wrap',
    display: 'flex'
  };
});
exports.StyledWeek = StyledWeek;
var StyledDay = (0, _index.styled)('div', function (props) {
  var $isHovered = props.$isHovered,
      $isHighlighted = props.$isHighlighted,
      $outsideMonth = props.$outsideMonth,
      $disabled = props.$disabled,
      $selected = props.$selected,
      _props$$theme3 = props.$theme,
      colors = _props$$theme3.colors,
      sizing = _props$$theme3.sizing,
      borders = _props$$theme3.borders;
  return {
    boxSizing: 'border-box',
    cursor: $disabled ? 'default' : 'pointer',
    display: 'inline-block',
    width: sizing.scale1000,
    height: sizing.scale1000,
    lineHeight: sizing.scale800,
    textAlign: 'center',
    paddingTop: sizing.scale300,
    paddingBottom: sizing.scale300,
    paddingLeft: sizing.scale200,
    paddingRight: sizing.scale200,
    marginTop: '0',
    marginBottom: '0',
    marginLeft: '0',
    marginRight: '0',
    color: $selected ? colors.white : $outsideMonth || $disabled ? colors.mono600 : 'inherit',
    backgroundColor: $selected ? colors.primary : $isHovered || $isHighlighted ? colors.primary100 : 'transparent',
    borderRadius: borders.useRoundedCorners ? borders.radius200 : '0px'
  };
});
exports.StyledDay = StyledDay;