"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../../link/index.js");

var _index2 = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Breadcrumbs', function () {
  it('applies correct accessibility attributes to root element', function () {
    var example = (0, _enzyme.shallow)(_react.default.createElement(_index2.Breadcrumbs, null, _react.default.createElement(_index.StyledLink, {
      href: "#"
    }, "Parent Page"), _react.default.createElement(_index.StyledLink, {
      href: "#"
    }, "Sub-Parent Page"), _react.default.createElement("span", null, "Current Page")));
    expect(example).toHaveProp('aria-label', 'Breadcrumbs navigation');
  });
  it('displays separators in correct positions', function () {
    expect((0, _enzyme.shallow)(_react.default.createElement(_index2.Breadcrumbs, null, _react.default.createElement(_index.StyledLink, {
      href: "#"
    }, "Parent Page"), _react.default.createElement(_index.StyledLink, {
      href: "#"
    }, "Sub-Parent Page"), _react.default.createElement("span", null, "Current Page")))).toMatchSnapshot();
  });
});