"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

var _images = require("../images.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
test('Card - basic functionality', function () {
  var props = {
    action: _react.default.createElement("a", {
      href: "#test"
    }, "Link to a Place\xA0\xA0\xA0>"),
    headerImage: _images.header,
    thumbnail: _images.thumbnail,
    title: 'Card title'
  };
  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_index.Card, props, "Card body")); // Renders input, label and caption

  expect(wrapper.find('img')).toHaveLength(2);
});
test('Card - no images', function () {
  var props = {
    action: _react.default.createElement("a", {
      href: "#test"
    }, "Link to a Place\xA0\xA0\xA0>"),
    title: 'Card title'
  };
  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_index.Card, props, "Card body")); // Renders input, label and caption

  expect(wrapper.find('img')).toHaveLength(0);
});