"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _index = require("../icon/index.js");

var _index2 = require("../select/index.js");

var _styledComponents = require("./styled-components.js");

var _index3 = require("./utils/index.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CalendarHeader =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CalendarHeader, _React$Component);

  function CalendarHeader() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CalendarHeader);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CalendarHeader)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleMonthChange", function (_ref) {
      var value = _ref.value;

      _this.props.onMonthChange({
        date: (0, _index3.setMonth)(_this.props.date, value[0].id)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleYearChange", function (_ref2) {
      var value = _ref2.value;

      _this.props.onYearChange({
        date: (0, _index3.setYear)(_this.props.date, value[0].id)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "increaseMonth", function () {
      _this.props.onMonthChange({
        date: (0, _index3.addMonths)(_this.props.date, 1)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "decreaseMonth", function () {
      _this.props.onMonthChange({
        date: (0, _index3.subMonths)(_this.props.date, 1)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderPreviousMonthButton", function () {
      var allPrevDaysDisabled = (0, _index3.monthDisabledBefore)(_this.props.date, _this.props);

      if (allPrevDaysDisabled) {
        return;
      }

      var clickHandler = _this.decreaseMonth;

      if (allPrevDaysDisabled) {
        clickHandler = null;
      }

      return React.createElement(_index.ArrowLeft, {
        role: "button",
        onClick: clickHandler,
        overrides: {
          Svg: {
            style: {
              cursor: 'pointer'
            }
          }
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderNextMonthButton", function () {
      var allNextDaysDisabled = (0, _index3.monthDisabledAfter)(_this.props.date, _this.props);

      if (allNextDaysDisabled) {
        return;
      }

      var clickHandler = _this.increaseMonth;

      if (allNextDaysDisabled) {
        clickHandler = null;
      }

      return React.createElement(_index.ArrowRight, {
        role: "button",
        onClick: clickHandler,
        overrides: {
          Svg: {
            style: {
              cursor: 'pointer'
            }
          }
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "setActive", function () {
      _this.props.setActiveState(true);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "setInactive", function () {
      _this.props.setActiveState(false);
    });

    return _this;
  }

  _createClass(CalendarHeader, [{
    key: "getSelectOverrides",
    value: function getSelectOverrides(_ref3) {
      var width = _ref3.width;
      return {
        ControlContainer: {
          style: function style(props) {
            var $isFocused = props.$isFocused,
                $isPseudoFocused = props.$isPseudoFocused,
                colors = props.$theme.colors;
            return {
              width: width,
              backgroundColor: colors.primary,
              color: colors.white,
              borderColor: $isFocused || $isPseudoFocused ? colors.white : colors.primary
            };
          }
        },
        IconsContainer: {
          style: {
            paddingRight: '0'
          }
        },
        SelectArrow: {
          style: function style(_ref4) {
            var colors = _ref4.$theme.colors;
            return {
              color: 'inherit'
            };
          }
        },
        ValueContainer: {
          style: function style(_ref5) {
            var sizing = _ref5.$theme.sizing;
            return {
              paddingTop: '0',
              paddingBottom: '0',
              paddingLeft: sizing.scale200,
              paddingRight: '0'
            };
          }
        },
        SingleValue: {
          style: function style(_ref6) {
            var sizing = _ref6.$theme.sizing;
            return {
              paddingTop: '0',
              paddingBottom: '0',
              paddingLeft: sizing.scale200,
              paddingRight: '0'
            };
          }
        }
      };
    }
  }, {
    key: "renderMonthDropdown",
    value: function renderMonthDropdown() {
      var _this2 = this;

      var monthOptions = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11].map(function (M) {
        return {
          id: M,
          label: (0, _index3.getMonthInLocale)(M, _this2.props.locale)
        };
      });
      return React.createElement(_index2.Select, {
        onOpen: this.setInactive,
        onClose: this.setActive,
        overrides: this.getSelectOverrides({
          width: '115px'
        }),
        clearable: false,
        value: [{
          id: (0, _index3.getMonth)(this.props.date)
        }],
        maxDropdownHeight: '300px' // $FlowFixMe
        ,
        onChange: this.handleMonthChange,
        options: monthOptions,
        searchable: false
      });
    }
  }, {
    key: "renderYearDropdown",
    value: function renderYearDropdown() {
      var minYear = this.props.minDate ? (0, _index3.getYear)(this.props.minDate) : 1900;
      var maxYear = this.props.maxDate ? (0, _index3.getYear)(this.props.maxDate) : 2100;
      var yearOptions = [];

      for (var i = minYear; i <= maxYear; i++) {
        yearOptions.push({
          id: i,
          label: i
        });
      }

      return React.createElement(_index2.Select, {
        onOpen: this.setInactive,
        onClose: this.setActive,
        overrides: this.getSelectOverrides({
          width: '80px'
        }),
        clearable: false,
        value: [{
          id: (0, _index3.getYear)(this.props.date)
        }],
        maxDropdownHeight: '300px' // $FlowFixMe
        ,
        onChange: this.handleYearChange,
        options: yearOptions,
        searchable: false
      });
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(_styledComponents.StyledHeader, null, this.renderPreviousMonthButton(), this.renderMonthDropdown(), this.renderYearDropdown(), this.renderNextMonthButton());
    }
  }]);

  return CalendarHeader;
}(React.Component);

exports.default = CalendarHeader;

_defineProperty(CalendarHeader, "defaultProps", {
  date: new Date(),
  locale: null,
  maxDate: null,
  minDate: null,
  onMonthChange: function onMonthChange() {},
  onYearChange: function onYearChange() {},
  setActiveState: function setActiveState() {}
});