"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _calendarHeader = _interopRequireDefault(require("./calendar-header.js"));

var _month = _interopRequireDefault(require("./month.js"));

var _styledComponents = require("./styled-components.js");

var _index = require("./utils/index.js");

var _constants = require("./constants.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Calendar =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Calendar, _React$Component);

  function Calendar(props) {
    var _this;

    _classCallCheck(this, Calendar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Calendar).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getDateInView", function () {
      var _this$props = _this.props,
          highlightedDate = _this$props.highlightedDate,
          selected = _this$props.selected;
      var minDate = (0, _index.getEffectiveMinDate)(_this.props);
      var maxDate = (0, _index.getEffectiveMaxDate)(_this.props);
      var current = new Date();
      var initialDate = selected || highlightedDate;

      if (initialDate) {
        return initialDate;
      } else {
        if (minDate && (0, _index.isBefore)(current, minDate)) {
          return minDate;
        } else if (maxDate && (0, _index.isAfter)(current, maxDate)) {
          return maxDate;
        }
      }

      return current;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleDayClick", function (_ref) {
      var date = _ref.date,
          event = _ref.event;

      _this.props.onSelect({
        date: date
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleMonthChange", function (date) {
      if (_this.props.onMonthChange) {
        _this.props.onMonthChange({
          date: date
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleYearChange", function (date) {
      if (_this.props.onYearChange) {
        _this.props.onYearChange({
          date: date
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "changeMonth", function (_ref2) {
      var date = _ref2.date;

      _this.setState({
        date: date
      }, function () {
        return _this.handleMonthChange(_this.state.date);
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "changeYear", function (_ref3) {
      var date = _ref3.date;

      _this.setState({
        date: date
      }, function () {
        return _this.handleYearChange(_this.state.date);
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderCalendarHeader", function () {
      var date = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.date;
      var order = arguments.length > 1 ? arguments[1] : undefined;
      return _react.default.createElement(_calendarHeader.default, _extends({}, _this.props, {
        key: "month-header-".concat(order),
        date: date,
        order: order,
        onMonthChange: _this.changeMonth,
        onYearChange: _this.changeYear
      }));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderMonthHeader", function () {
      var date = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.date;
      var order = arguments.length > 1 ? arguments[1] : undefined;
      var locale = _this.props.locale;
      var startOfWeek = (0, _index.getStartOfWeek)(date, locale);
      return _react.default.createElement(_styledComponents.StyledMonthHeader, null, _constants.WEEKDAYS.map(function (offset) {
        var day = (0, _index.addDays)(startOfWeek, offset);
        return _react.default.createElement(_styledComponents.StyledDay, {
          $disabled: true,
          key: offset
        }, (0, _index.getWeekdayMinInLocale)(day, locale));
      }));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderMonths", function () {
      var monthList = [];

      for (var i = 0; i < _this.props.monthsShown; ++i) {
        var monthDate = (0, _index.addMonths)(_this.state.date, i);
        var monthKey = "month-".concat(i);
        monthList.push(_this.renderCalendarHeader(monthDate, i));
        monthList.push(_react.default.createElement(_styledComponents.StyledCalendarContainer, {
          key: monthKey
        }, _this.renderMonthHeader(monthDate, i), _react.default.createElement(_month.default, {
          date: monthDate,
          excludeDates: _this.props.excludeDates,
          filterDate: _this.props.filterDate,
          highlightDates: _this.props.highlightDates,
          highlightedDate: _this.props.highlightedDate,
          includeDates: _this.props.includeDates,
          locale: _this.props.locale,
          maxDate: _this.props.maxDate,
          minDate: _this.props.minDate,
          month: (0, _index.getMonth)(_this.state.date),
          onDayClick: _this.props.onDayClick,
          onDayMouseOver: _this.props.onDayMouseOver,
          onDayMouseLeave: _this.props.onDayMouseLeave,
          onSelect: _this.props.onSelect,
          selected: _this.props.selected,
          peekNextMonth: _this.props.peekNextMonth
        })));
      }

      return monthList;
    });

    _this.state = {
      date: _this.getDateInView()
    };
    return _this;
  }

  _createClass(Calendar, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.highlightedDate && !(0, _index.isSameDay)(this.props.highlightedDate, prevProps.highlightedDate)) {
        this.setState({
          date: this.props.highlightedDate
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_styledComponents.StyledRoot, null, this.renderMonths());
    }
  }]);

  return Calendar;
}(_react.default.Component);

exports.default = Calendar;

_defineProperty(Calendar, "defaultProps", {
  excludeDates: null,
  filterDate: null,
  highlightDates: null,
  highlightedDate: null,
  includeDates: null,
  locale: null,
  maxDate: null,
  minDate: null,
  monthsShown: 1,
  onDayClick: function onDayClick() {},
  onDayMouseOver: function onDayMouseOver() {},
  onDayMouseLeave: function onDayMouseLeave() {},
  onMonthChange: function onMonthChange() {},
  onYearChange: function onYearChange() {},
  onSelect: function onSelect() {},
  peekNextMonth: false,
  selected: null,
  setActiveState: function setActiveState() {}
});