"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = require("./styled-components.js");

var _index = require("./utils/index.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Day =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Day, _React$Component);

  function Day() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Day);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Day)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      isHovered: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onKeyDown", function (event) {
      var _this$props = _this.props,
          isHighlighted = _this$props.isHighlighted,
          date = _this$props.date,
          disabled = _this$props.disabled,
          onSelect = _this$props.onSelect;

      if (event.key === 'Enter' && isHighlighted && !disabled) {
        event.preventDefault();
        onSelect({
          date: date
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function (event) {
      var _this$props2 = _this.props,
          date = _this$props2.date,
          disabled = _this$props2.disabled;

      if (!disabled) {
        _this.props.onSelect({
          date: date
        });

        _this.props.onClick({
          event: event,
          date: date
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onMouseOver", function (event) {
      _this.setState({
        isHovered: true
      });

      _this.props.onMouseOver({
        event: event,
        date: _this.props.date
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onMouseLeave", function (event) {
      _this.setState({
        isHovered: false
      });

      _this.props.onMouseLeave({
        event: event,
        date: _this.props.date
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isWeekend", function () {
      var weekday = (0, _index.getDay)(_this.props.date);
      return weekday === 0 || weekday === 6;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isOutsideMonth", function () {
      return _this.props.month !== undefined && _this.props.month !== (0, _index.getMonth)(_this.props.date);
    });

    return _this;
  }

  _createClass(Day, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.isHighlighted) {
        if (typeof document !== 'undefined') {
          document.addEventListener('keydown', this.onKeyDown);
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.isHighlighted && this.props.isHighlighted !== prevProps.isHighlighted) {
        if (typeof document !== 'undefined') {
          document.addEventListener('keydown', this.onKeyDown);
        }
      } else if (!this.props.isHighlighted && this.props.isHighlighted !== prevProps.isHighlighted) {
        if (typeof document !== 'undefined') {
          document.removeEventListener('keydown', this.onKeyDown);
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (typeof document !== 'undefined') {
        document.removeEventListener('keydown', this.onKeyDown);
      }
    }
  }, {
    key: "getSharedProps",
    value: function getSharedProps() {
      return {
        $disabled: this.props.disabled,
        $isHovered: this.state.isHovered,
        $isHighlighted: this.props.isHighlighted,
        // $pseudoSelected: this.props.pseudoSelected,
        $selected: this.props.selected,
        $today: (0, _index.isSameDay)(this.props.date, new Date()),
        $weekend: this.isWeekend(),
        $outsideMonth: this.isOutsideMonth()
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          date = _this$props3.date,
          peekNextMonth = _this$props3.peekNextMonth;
      var sharedProps = this.getSharedProps();
      return !peekNextMonth && sharedProps.$outsideMonth ? React.createElement(_styledComponents.StyledDay, null) : // eslint-disable-next-line jsx-a11y/mouse-events-have-key-events
      React.createElement(_styledComponents.StyledDay, _extends({
        onClick: this.onClick,
        onMouseOver: this.onMouseOver,
        onMouseLeave: this.onMouseLeave,
        "aria-label": "day-".concat((0, _index.getDate)(date)),
        role: "option",
        tabIndex: this.props.selected ? '0' : '-1'
      }, sharedProps), (0, _index.getDate)(date));
    }
  }]);

  return Day;
}(React.Component);

exports.default = Day;

_defineProperty(Day, "defaultProps", {
  disabled: false,
  date: new Date(),
  isHighlighted: false,
  month: new Date().getMonth(),
  onClick: function onClick() {},
  onSelect: function onSelect() {},
  onMouseOver: function onMouseOver() {},
  onMouseLeave: function onMouseLeave() {},
  peekNextMonth: true,
  selected: false // pseudoSelected: false,

});