"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledRejectedFile = exports.StyledAcceptedFile = exports.StyledHiddenInput = exports.StyledFilesList = exports.StyledRoot = exports.StyledContentSeparator = exports.StyledContentMessage = exports.StyledFileDragAndDrop = void 0;

var _index = require("../styles/index.js");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StyledFileDragAndDrop = (0, _index.styled)('div', function (props) {
  return {
    alignItems: 'center',
    backgroundColor: props.$theme.colors.fileUploaderBackgroundColor,
    borderColor: props.$isDragActive ? props.$theme.colors.fileUploaderBorderColorActive : props.$theme.colors.fileUploaderBorderColorDefault,
    borderStyle: 'dashed',
    borderRadius: props.$theme.borders.useRoundedCorners ? props.$theme.borders.radius200 : null,
    borderWidth: props.$theme.sizing.scale0,
    boxSizing: 'border-box',
    display: 'flex',
    flexDirection: 'column',
    outline: props.$isDisabled ? 'none' : null,
    paddingTop: props.$theme.sizing.scale900,
    paddingRight: props.$theme.sizing.scale800,
    paddingBottom: props.$theme.sizing.scale900,
    paddingLeft: props.$theme.sizing.scale800,
    width: '100%'
  };
});
exports.StyledFileDragAndDrop = StyledFileDragAndDrop;
StyledFileDragAndDrop.displayName = 'StyledFileDragAndDrop';
var StyledContentMessage = (0, _index.styled)('div', function (props) {
  return _objectSpread({}, props.$theme.typography.font450);
});
exports.StyledContentMessage = StyledContentMessage;
StyledContentMessage.displayName = 'StyledContentMessage';
var StyledContentSeparator = (0, _index.styled)('div', function (props) {
  return {
    color: props.$theme.colors.fileUploaderSeparatorColor
  };
});
exports.StyledContentSeparator = StyledContentSeparator;
StyledContentSeparator.displayName = 'StyledContentSeparator';
var StyledRoot = (0, _index.styled)('div', function (props) {
  return _objectSpread({}, props.$theme.typography.font450);
});
exports.StyledRoot = StyledRoot;
StyledRoot.displayName = 'StyledRoot';
var StyledFilesList = (0, _index.styled)('ul');
exports.StyledFilesList = StyledFilesList;
StyledFilesList.displayName = 'StyledFilesList';
var StyledHiddenInput = (0, _index.styled)('input');
exports.StyledHiddenInput = StyledHiddenInput;
StyledHiddenInput.displayName = 'StyledHiddenInput';
var StyledAcceptedFile = (0, _index.styled)('li');
exports.StyledAcceptedFile = StyledAcceptedFile;
StyledAcceptedFile.displayName = 'StyledAcceptedFile';
var StyledRejectedFile = (0, _index.styled)('li', function (props) {
  return {
    color: props.$theme.colors.negative400
  };
});
exports.StyledRejectedFile = StyledRejectedFile;
StyledRejectedFile.displayName = 'StyledRejectedFile';