"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _index = require("../helpers/index.js");

var _index2 = require("../button/index.js");

var _index3 = require("../menu/index.js");

var _index4 = require("../select/index.js");

var _index5 = require("../styles/index.js");

var _examplesColors = _interopRequireDefault(require("../select/examples-colors.json"));

var _examplesIcons = require("./examples-icons.js");

var _index6 = require("./index.js");

var _examplesList = _interopRequireDefault(require("./examples-list.js"));

var _tests$HEADER_NAVIGAT;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Link = (0, _index.withProps)((0, _index5.styled)('a', function (props) {
  return {
    ':hover': {
      color: props.$theme.colors.primary400
    }
  };
}), {
  tabIndex: '0'
}); // $FlowFixMe

Link.displayName = 'Link';
var Hamburger = (0, _index5.styled)('div', function (props) {
  return {
    lineHeight: 'initial'
  };
});
Hamburger.displayName = 'Hamburger';
var StyledHamburgerIcon = (0, _index5.styled)('span', function (props) {
  return {
    ':after': {
      content: "url('data:image/svg+xml;utf8,".concat((0, _examplesIcons.HamburgerIcon)(props.$theme.colors.foreground), "');")
    }
  };
});
var ExtraStyledNavigationList = (0, _index5.styled)(_index6.StyledNavigationList, function (props) {
  return {
    backgroundColor: 'red'
  };
});
var ITEMS = [];

for (var i = 0; i < 100; i++) {
  ITEMS.push({
    label: "Item ".concat(i)
  });
}

var options = {
  options: _examplesColors.default,
  labelKey: 'id',
  valueKey: 'color',
  placeholder: 'Choose a color',
  maxDropdownHeight: '300px'
};

var MenuContainer =
/*#__PURE__*/
function (_React$Component) {
  _inherits(MenuContainer, _React$Component);

  function MenuContainer() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MenuContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MenuContainer)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      isOpen: _this.props.isOpen
    });

    return _this;
  }

  _createClass(MenuContainer, [{
    key: "toggleMenu",
    value: function toggleMenu() {
      this.setState({
        isOpen: !this.state.isOpen
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(React.Fragment, null, React.createElement(Hamburger, {
        tabIndex: "0",
        "aria-label": "Navigation menu",
        onKeyDown: function onKeyDown(e) {
          switch (e.key) {
            case _index3.KEY_STRINGS.ArrowDown:
            case _index3.KEY_STRINGS.Space:
            case _index3.KEY_STRINGS.Enter:
              _this2.toggleMenu();

              return;
          }
        },
        onClick: function onClick() {
          return _this2.toggleMenu();
        }
      }, React.createElement(StyledHamburgerIcon, null)), this.state.isOpen && React.createElement(_index3.StatefulMenu, {
        items: ITEMS,
        overrides: {
          List: {
            style: {
              cursor: 'pointer',
              position: 'absolute',
              height: '90vh',
              right: this.props.align === _index6.ALIGN.right ? '0' : 'initial'
            }
          }
        }
      }));
    }
  }]);

  return MenuContainer;
}(React.Component);

_defineProperty(MenuContainer, "defaultProps", {
  isOpen: false,
  align: ''
});

var _default = (_tests$HEADER_NAVIGAT = {}, _defineProperty(_tests$HEADER_NAVIGAT, _examplesList.default.HEADER_NAVIGATION_WITH_MENU_ELEMENT, function () {
  return React.createElement(React.Fragment, null, React.createElement("div", {
    style: {
      marginTop: '50px'
    }
  }), React.createElement(_index6.HeaderNavigation, null, React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.left
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(MenuContainer, null)), React.createElement(_index6.StyledNavigationItem, null, "Uber")), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.center
  }), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link One")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Two")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Three"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(_index2.Button, null, "Get started")))));
}), _defineProperty(_tests$HEADER_NAVIGAT, _examplesList.default.HEADER_NAVIGATION_WITH_RIGHT_MENU, function () {
  return React.createElement(React.Fragment, null, React.createElement("div", {
    style: {
      marginTop: '50px'
    }
  }), React.createElement(_index6.HeaderNavigation, null, React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.center
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link One")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Two")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Three"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, "Uber"), React.createElement(_index6.StyledNavigationItem, null, React.createElement(MenuContainer, {
    align: _index6.ALIGN.right
  })))));
}), _defineProperty(_tests$HEADER_NAVIGAT, _examplesList.default.HEADER_NAVIGATION_WITH_OVERRIDES, function () {
  return React.createElement(React.Fragment, null, React.createElement("div", {
    style: {
      marginTop: '50px'
    }
  }), React.createElement(_index6.HeaderNavigation, {
    overrides: {
      Root: {
        style: {
          backgroundColor: 'lightblue'
        }
      }
    }
  }, React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.left
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(MenuContainer, null)), React.createElement(_index6.StyledNavigationItem, null, "Uber")), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link One")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Two")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Three"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(_index2.Button, null, "Get started")))));
}), _defineProperty(_tests$HEADER_NAVIGAT, _examplesList.default.HEADER_NAVIGATION_SEARCH_BAR, function () {
  return React.createElement(React.Fragment, null, React.createElement("div", {
    style: {
      marginTop: '50px'
    }
  }), React.createElement(_index6.HeaderNavigation, null, React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.left
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(MenuContainer, null)), React.createElement(_index6.StyledNavigationItem, null, "Uber")), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.center
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link One")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Two")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Tab Link Three"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, {
    style: {
      width: '300px'
    }
  }, React.createElement(_index4.StatefulSelect, _extends({}, options, {
    type: _index4.TYPE.search,
    getOptionLabel: function getOptionLabel(props) {
      return props.option.id || null;
    },
    onChange: function onChange() {},
    rows: 8,
    multi: true
  }))))));
}), _defineProperty(_tests$HEADER_NAVIGAT, _examplesList.default.HEADER_NAVIGATION_DIFFERENT_ALIGNMENTS, function () {
  return React.createElement(React.Fragment, null, React.createElement("div", {
    style: {
      marginTop: '50px'
    }
  }), React.createElement(_index6.HeaderNavigation, null, React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.left
  }, React.createElement(_index6.StyledNavigationItem, null, "Uber")), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.center
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Centered Tab Link One")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Centered Tab Link Two")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Centered Tab Link Three"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Right Aligned Link"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(_index2.Button, null, "Get started")))));
}), _defineProperty(_tests$HEADER_NAVIGAT, _examplesList.default.HEADER_NAVIGATION_STYLED_NAV_LIST, function () {
  return React.createElement(React.Fragment, null, React.createElement("div", {
    style: {
      marginTop: '50px'
    }
  }), React.createElement(_index6.HeaderNavigation, null, React.createElement(ExtraStyledNavigationList, {
    align: _index6.ALIGN.left
  }, React.createElement(_index6.StyledNavigationItem, null, "Uber")), React.createElement(ExtraStyledNavigationList, {
    align: _index6.ALIGN.center
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Centered Tab Link One")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Centered Tab Link Two")), React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Centered Tab Link Three"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(Link, null, "Right Aligned Link"))), React.createElement(_index6.StyledNavigationList, {
    align: _index6.ALIGN.right
  }, React.createElement(_index6.StyledNavigationItem, null, React.createElement(_index2.Button, null, "Get started")))));
}), _tests$HEADER_NAVIGAT);

exports.default = _default;