"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProfileBody = exports.ProfileSubtitle = exports.ProfileTitle = exports.ProfileLabelsContainer = exports.ProfileImg = exports.ProfileImgContainer = exports.ListItemProfile = exports.ListItem = exports.List = void 0;

var _index = require("../styles/index.js");

var _constants = require("./constants.js");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var List = (0, _index.styled)('ul', function (_ref) {
  var $theme = _ref.$theme;
  return {
    position: 'relative',
    marginTop: '0',
    marginBottom: '0',
    marginLeft: '0',
    marginRight: '0',
    paddingTop: '0',
    paddingBottom: '0',
    paddingLeft: '0',
    paddingRight: '0',
    backgroundColor: $theme.colors.backgroundAlt,
    borderRadius: $theme.borders.radius300,
    boxShadow: $theme.lighting.shadow600,
    overflow: 'auto'
  };
});
exports.List = List;
List.displayName = 'StyledList';
var ListItem = (0, _index.styled)('li', function (_ref2) {
  var $theme = _ref2.$theme,
      $isHighlighted = _ref2.$isHighlighted,
      $size = _ref2.$size;
  return _objectSpread({}, $size === _constants.OPTION_LIST_SIZE.compact ? $theme.typography.font200 : $theme.typography.font300, {
    position: 'relative',
    display: 'block',
    color: $isHighlighted ? $theme.colors.primary : $theme.colors.foreground,
    cursor: 'pointer',
    backgroundColor: $isHighlighted ? $theme.colors.mono300 : 'transparent',
    transitionProperty: 'color, background-color',
    transitionDuration: $theme.animation.timing100,
    transitionTimingFunction: $theme.animation.easeOutCurve,
    ':hover': {
      backgroundColor: $theme.colors.menuFillHover
    },
    paddingTop: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale100 : $theme.sizing.scale300,
    paddingBottom: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale100 : $theme.sizing.scale300,
    paddingRight: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale900 : $theme.sizing.scale600,
    paddingLeft: $size === _constants.OPTION_LIST_SIZE.compact ? $theme.sizing.scale900 : $theme.sizing.scale600,
    ':first-child': {
      marginTop: $theme.sizing.scale300
    },
    ':last-child': {
      marginBottom: $theme.sizing.scale300
    }
  });
});
exports.ListItem = ListItem;
ListItem.displayName = 'StyledListItem';
var ListItemProfile = (0, _index.styled)('li', function (_ref3) {
  var $theme = _ref3.$theme;
  return {
    position: 'relative',
    display: 'flex',
    alignItems: 'center',
    cursor: 'pointer',
    paddingTop: $theme.sizing.scale300,
    paddingBottom: $theme.sizing.scale300,
    paddingRight: $theme.sizing.scale800,
    paddingLeft: $theme.sizing.scale800,
    transitionProperty: 'color, background-color',
    transitionDuration: $theme.animation.timing100,
    transitionTimingFunction: $theme.animation.easeOutCurve,
    ':hover': {
      backgroundColor: $theme.colors.menuFillHover
    },
    ':first-child': {
      marginTop: $theme.sizing.scale300
    },
    ':last-child': {
      marginBottom: $theme.sizing.scale300
    }
  };
});
exports.ListItemProfile = ListItemProfile;
ListItemProfile.displayName = 'StyledListItemProfile';
var ProfileImgContainer = (0, _index.styled)('div', {
  width: '60px',
  height: '60px',
  display: 'flex',
  justifyContent: 'center',
  alignItems: 'center'
});
exports.ProfileImgContainer = ProfileImgContainer;
ProfileImgContainer.displayName = 'StyledProfileImgContainer';
var ProfileImg = (0, _index.styled)('img', {
  width: '100%',
  height: '100%',
  borderRadius: '50%'
});
exports.ProfileImg = ProfileImg;
ProfileImg.displayName = 'StyledProfileImg';
var ProfileLabelsContainer = (0, _index.styled)('div', function (_ref4) {
  var $theme = _ref4.$theme;
  return {
    marginLeft: $theme.sizing.scale600,
    alignSelf: 'flex-start',
    display: 'flex',
    flexDirection: 'column'
  };
});
exports.ProfileLabelsContainer = ProfileLabelsContainer;
ProfileLabelsContainer.displayName = 'StyledProfileLabelsContainer';
var ProfileTitle = (0, _index.styled)('h6', function (_ref5) {
  var $theme = _ref5.$theme;
  return _objectSpread({}, $theme.typography.font450, {
    color: $theme.colors.foreground,
    marginTop: '0',
    marginBottom: '0',
    marginLeft: '0',
    marginRight: '0'
  });
});
exports.ProfileTitle = ProfileTitle;
ProfileTitle.displayName = 'StyledProfileTitle';
var ProfileSubtitle = (0, _index.styled)('p', function (_ref6) {
  var $theme = _ref6.$theme;
  return _objectSpread({}, $theme.typography.font300, {
    color: $theme.colors.foreground,
    marginTop: '0',
    marginBottom: '0',
    marginLeft: '0',
    marginRight: '0'
  });
});
exports.ProfileSubtitle = ProfileSubtitle;
ProfileSubtitle.displayName = 'StyledProfileSubtitle';
var ProfileBody = (0, _index.styled)('p', function (_ref7) {
  var $theme = _ref7.$theme;
  return _objectSpread({}, $theme.typography.font200, {
    color: $theme.colors.foregroundAlt,
    marginTop: '0',
    marginBottom: '0',
    marginLeft: '0',
    marginRight: '0'
  });
});
exports.ProfileBody = ProfileBody;
ProfileBody.displayName = 'StyledProfileBody';