"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropdownButton = exports.DropdownMenu = exports.DropdownContainer = exports.MaxLabel = exports.Root = void 0;

var _index = require("../styles/index.js");

var _index2 = require("../menu/index.js");

var _index3 = require("../button/index.js");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Root = (0, _index.styled)('div', {
  display: 'flex',
  alignItems: 'center'
});
exports.Root = Root;
Root.displayName = 'StyledRoot';
var MaxLabel = (0, _index.styled)('span', function (_ref) {
  var $theme = _ref.$theme;
  return _objectSpread({}, $theme.typography.font300, {
    marginLeft: $theme.sizing.scale300,
    marginRight: $theme.sizing.scale600
  });
});
exports.MaxLabel = MaxLabel;
MaxLabel.displayName = 'StyledMaxLabel';
var DropdownContainer = (0, _index.styled)('div', function (_ref2) {
  var $theme = _ref2.$theme;
  return {
    position: 'relative',
    marginLeft: $theme.sizing.scale600,
    marginRight: $theme.sizing.scale300
  };
});
exports.DropdownContainer = DropdownContainer;
DropdownContainer.displayName = 'StyledDropdownContainer';
var DropdownMenu = (0, _index.styled)(_index2.StyledList, function (_ref3) {
  var $theme = _ref3.$theme;
  return {
    position: 'absolute',
    overflow: 'auto',
    maxHeight: '200px',
    top: 'auto',
    marginTop: $theme.sizing.scale300,
    left: 0,
    right: 0
  };
});
exports.DropdownMenu = DropdownMenu;
DropdownMenu.displayName = 'StyledDropdownMenu';
var DropdownButton = (0, _index.styled)(_index3.StyledBaseButton, function (_ref4) {
  var $theme = _ref4.$theme;
  return {
    color: $theme.colors.foreground,
    minWidth: "calc(".concat($theme.sizing.scale1600, " + ").concat($theme.sizing.scale400, ")")
  };
});
exports.DropdownButton = DropdownButton;
DropdownButton.displayName = 'StyledDropdownButton';