"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.suite = void 0;

var React = _interopRequireWildcard(require("react"));

var _styletronReact = require("styletron-react");

var _index = require("./index.js");

var _examplesList = _interopRequireDefault(require("./examples-list.js"));

var _examples$SIMPLE_EXAM;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var suite = 'Radio Group Test Suite';
exports.suite = suite;

var _default = (_examples$SIMPLE_EXAM = {}, _defineProperty(_examples$SIMPLE_EXAM, _examplesList.default.SIMPLE_EXAMPLE, function () {
  return React.createElement(_index.StatefulRadioGroup, {
    initialState: {
      value: '2'
    }
  }, React.createElement(_index.StyledRadio, {
    value: "1"
  }, "First"), React.createElement(_index.StyledRadio, {
    value: "2"
  }, "Second"), React.createElement(_index.StyledRadio, {
    value: "3"
  }, "Third"));
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList.default.HORIZONTAL_ALIGN, function () {
  return React.createElement(_index.StatefulRadioGroup, {
    align: "horizontal",
    initialState: {
      value: '3'
    }
  }, React.createElement(_index.StyledRadio, {
    value: "1"
  }, "First"), React.createElement(_index.StyledRadio, {
    value: "2"
  }, "Second"), React.createElement(_index.StyledRadio, {
    value: "3"
  }, "Third"));
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList.default.COMPONENTS_OVERRIDES, function () {
  var overrides = {
    Label: function Label(props) {
      return React.createElement("div", null, "Custom Label for value ", props.$value);
    }
  };
  return React.createElement(_index.StatefulRadioGroup, {
    overrides: overrides,
    initialState: {
      value: '3'
    }
  }, React.createElement(_index.StyledRadio, {
    value: "1"
  }, "First"), React.createElement(_index.StyledRadio, {
    value: "2"
  }, "Second"), React.createElement(_index.StyledRadio, {
    value: "3"
  }, "Third"));
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList.default.STYLES_OVERRIDES, function () {
  var overrides = {
    RadioMark: {
      style: {
        borderColor: 'red'
      }
    },
    Label: (0, _styletronReact.withStyle)(_index.StyledLabel, function () {
      return {
        color: 'orange',
        fontSize: '25px'
      };
    })
  };
  return React.createElement(_index.StatefulRadioGroup, {
    overrides: overrides,
    initialState: {
      value: '3'
    }
  }, React.createElement(_index.StyledRadio, {
    value: "1"
  }, "First"), React.createElement(_index.StyledRadio, {
    value: "2"
  }, "Second"), React.createElement(_index.StyledRadio, {
    value: "3"
  }, "Third"));
}), _defineProperty(_examples$SIMPLE_EXAM, _examplesList.default.WITH_ERROR, function () {
  return React.createElement(_index.StatefulRadioGroup, {
    isError: true,
    initialState: {
      value: '3'
    }
  }, React.createElement(_index.StyledRadio, {
    value: "1"
  }, "First"), React.createElement(_index.StyledRadio, {
    value: "2"
  }, "Second"), React.createElement(_index.StyledRadio, {
    value: "3"
  }, "Third"));
}), _examples$SIMPLE_EXAM);

exports.default = _default;