"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

describe('Stateless tag', function () {
  var wrapper,
      events = {},
      children;
  var allProps = {},
      mockFn;
  beforeEach(function () {
    mockFn = jest.fn();
    events = {
      onActionClick: mockFn
    };
    allProps = _objectSpread({}, events);
    children = 'Some tag';
  });
  afterEach(function () {
    jest.restoreAllMocks();
    wrapper && wrapper.unmount();
  });
  test('should render component', function () {
    wrapper = (0, _enzyme.mount)(_react.default.createElement(_index.Tag, allProps, children));
    expect(wrapper).toMatchSnapshot('Component has correct render');
  });
  describe('On action', function () {
    beforeEach(function () {
      allProps.onActionClick = jest.fn();
      wrapper = (0, _enzyme.mount)(_react.default.createElement(_index.Tag, allProps, children));
    });
    test('should call callback if action button is clicked', function () {
      var actionIcon = wrapper.find(_index.StyledAction);
      actionIcon.first().simulate('click');
      expect(allProps.onActionClick).toHaveBeenCalledWith(allProps.onActionClick.mock.calls[0][0], children);
    });
  });
});