"use strict";

var React = _interopRequireWildcard(require("react"));

var _enzyme = require("enzyme");

var _step = _interopRequireDefault(require("../step.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Step', function () {
  it('applies isCompleted prop correctly', function () {
    expect((0, _enzyme.shallow)(React.createElement(_step.default, {
      isCompleted: true
    }))).toMatchSnapshot();
  });
  it('applies isActive prop correctly', function () {
    expect((0, _enzyme.shallow)(React.createElement(_step.default, {
      isActive: true
    }))).toMatchSnapshot();
  });
  it('applies isLast prop correctly', function () {
    expect((0, _enzyme.shallow)(React.createElement(_step.default, {
      isLast: true
    }))).toMatchSnapshot();
  });
  it('applies title prop correctly', function () {
    expect((0, _enzyme.shallow)(React.createElement(_step.default, {
      title: "Test Title"
    }))).toMatchSnapshot();
  });
  it('renders children correctly if isActive is provided', function () {
    expect((0, _enzyme.shallow)(React.createElement(_step.default, {
      isActive: true
    }, "Content"))).toMatchSnapshot();
  });
});