"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledNumberContentTail = exports.StyledNumberIcon = exports.StyledNumberStep = exports.StyledContentDescription = exports.StyledContentTail = exports.StyledContentTitle = exports.StyledContent = exports.StyledInnerIcon = exports.StyledIcon = exports.StyledStep = exports.StyledProgressSteps = void 0;

var _index = require("../styles/index.js");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StyledProgressSteps = (0, _index.styled)('div', function (_ref) {
  var $theme = _ref.$theme;
  return {
    paddingTop: $theme.sizing.scale300,
    paddingBottom: $theme.sizing.scale300
  };
});
exports.StyledProgressSteps = StyledProgressSteps;
StyledProgressSteps.displayName = 'StyledProgressSteps';
var StyledStep = (0, _index.styled)('div', function (_ref2) {
  var $theme = _ref2.$theme;
  return {
    position: 'relative',
    overflow: 'visible'
  };
});
exports.StyledStep = StyledStep;
StyledStep.displayName = 'StyledStep';
var StyledIcon = (0, _index.styled)('div', function (_ref3) {
  var $theme = _ref3.$theme,
      $isActive = _ref3.$isActive,
      $isCompleted = _ref3.$isCompleted,
      $disabled = _ref3.$disabled;
  var currentColor = $theme.colors.mono400;
  var size = $theme.sizing.scale300;
  var marginRight = $theme.sizing.scale500;
  var marginLeft = $theme.sizing.scale100;
  var font = $theme.typography.font400;

  if ($isCompleted) {
    currentColor = $theme.colors.primary400;
  } else if ($isActive) {
    font = $theme.typography.font450;
    currentColor = $theme.colors.primary100;
  }

  if ($isActive) {
    size = $theme.sizing.scale600;
    marginLeft = 0;
    marginRight = $theme.sizing.scale300;
  }

  var marginTop = "calc((".concat(font.lineHeight, " - ").concat(size, ") / 2)");
  return {
    marginRight: marginRight,
    marginLeft: marginLeft,
    marginTop: marginTop,
    width: size,
    height: size,
    lineHeight: size,
    borderRadius: size,
    backgroundColor: currentColor,
    float: 'left',
    textAlign: 'center',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center'
  };
});
exports.StyledIcon = StyledIcon;
StyledIcon.displayName = 'StyledIcon';
var StyledInnerIcon = (0, _index.styled)('div', function (_ref4) {
  var $theme = _ref4.$theme;
  return {
    width: $theme.sizing.scale100,
    height: $theme.sizing.scale100,
    lineHeight: $theme.sizing.scale100,
    borderRadius: $theme.sizing.scale100,
    backgroundColor: $theme.colors.primary400,
    textAlign: 'center'
  };
});
exports.StyledInnerIcon = StyledInnerIcon;
StyledInnerIcon.displayName = 'StyledInnerIcon';
var StyledContent = (0, _index.styled)('div', function (_ref5) {
  var $theme = _ref5.$theme;
  return {
    overflow: 'hidden'
  };
});
exports.StyledContent = StyledContent;
StyledContent.displayName = 'StyledContent';
var StyledContentTitle = (0, _index.styled)('div', function (_ref6) {
  var $theme = _ref6.$theme,
      $isActive = _ref6.$isActive;
  var color = $theme.colors.foregroundAlt;
  var font = $theme.typography.font400;

  if ($isActive) {
    color = $theme.colors.foreground;
    font = $theme.typography.font450;
  }

  return _objectSpread({}, font, {
    color: color
  });
});
exports.StyledContentTitle = StyledContentTitle;
StyledContentTitle.displayName = 'StyledContentTitle';
var StyledContentTail = (0, _index.styled)('div', function (_ref7) {
  var $theme = _ref7.$theme,
      $isCompleted = _ref7.$isCompleted;
  var currentColor = $theme.colors.mono400;

  if ($isCompleted) {
    currentColor = $theme.colors.primary400;
  }

  return {
    position: 'absolute',
    left: '7px',
    top: 0,
    height: '100%',
    zIndex: -1,
    paddingBottom: '0px',
    width: $theme.sizing.scale0,
    paddingTop: $theme.sizing.scale600,
    ':after': {
      content: '""',
      display: 'inline-block',
      height: '100%',
      width: '100%',
      backgroundColor: currentColor
    }
  };
});
exports.StyledContentTail = StyledContentTail;
StyledContentTail.displayName = 'StyledContentTail';
var StyledContentDescription = (0, _index.styled)('div', function (_ref8) {
  var $theme = _ref8.$theme;
  return {
    marginBottom: $theme.sizing.scale700
  };
});
exports.StyledContentDescription = StyledContentDescription;
StyledContentDescription.displayName = 'StyledContentDescription';
var StyledNumberStep = (0, _index.styled)('div', function (_ref9) {
  var $theme = _ref9.$theme;
  return {
    position: 'relative',
    overflow: 'visible'
  };
});
exports.StyledNumberStep = StyledNumberStep;
StyledNumberStep.displayName = 'StyledNumberStep';
var StyledNumberIcon = (0, _index.styled)('div', function (_ref10) {
  var $theme = _ref10.$theme,
      $isActive = _ref10.$isActive,
      $isCompleted = _ref10.$isCompleted,
      $disabled = _ref10.$disabled;
  var backgroundColor = $theme.colors.mono400;
  var color = $theme.colors.primary400;
  var size = $theme.sizing.scale800;
  var marginRight = $theme.sizing.scale300;
  var font = $theme.typography.font350;
  var titleFont = $theme.typography.font400;

  if ($isCompleted) {
    backgroundColor = $theme.colors.primary400;
    color = $theme.colors.mono100;
  } else if ($isActive) {
    titleFont = $theme.typography.font450;
    backgroundColor = $theme.colors.primary100;
  }

  var marginTop = "calc((".concat(titleFont.lineHeight, " - ").concat(size, ") / 2)");
  return _objectSpread({
    marginRight: marginRight,
    marginTop: marginTop,
    width: size,
    height: size,
    borderRadius: size,
    backgroundColor: backgroundColor,
    color: color,
    float: 'left',
    textAlign: 'center',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center'
  }, font);
});
exports.StyledNumberIcon = StyledNumberIcon;
StyledNumberIcon.displayName = 'StyledNumberIcon';
var StyledNumberContentTail = (0, _index.styled)('div', function (_ref11) {
  var $theme = _ref11.$theme,
      $isActive = _ref11.$isActive,
      $isCompleted = _ref11.$isCompleted,
      $disabled = _ref11.$disabled;
  var currentColor = $theme.colors.mono400;

  if ($isCompleted) {
    currentColor = $theme.colors.primary400;
  }

  return {
    position: 'absolute',
    left: '11px',
    top: 0,
    height: '100%',
    zIndex: -1,
    paddingBottom: '0px',
    width: $theme.sizing.scale0,
    paddingTop: $theme.sizing.scale600,
    ':after': {
      content: '""',
      display: 'inline-block',
      height: '100%',
      width: '100%',
      backgroundColor: currentColor
    }
  };
});
exports.StyledNumberContentTail = StyledNumberContentTail;
StyledNumberContentTail.displayName = 'StyledNumberContentTail';